package edu.lawrence.guipasswordmanager;

import java.io.File;
import java.io.PrintWriter;
import java.net.URL;
import java.util.ResourceBundle;
import java.util.Scanner;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Label;
import javafx.scene.control.ListView;
import javafx.scene.control.PasswordField;
import javafx.scene.control.TextField;

public class PrimaryController  implements Initializable {
    private ObservableList<Site> sites;

    @FXML ListView siteList;

    @FXML TextField nameField;
    @FXML TextField userField;
    @FXML PasswordField passwordField;

    @FXML Label userLabel;
    @FXML Label passwordLabel;

    @Override
    public void initialize(URL url, ResourceBundle rb) {
        sites = FXCollections.observableArrayList();
        Scanner input = null;
        try {
            input = new Scanner(new File("passwords.txt"));
        } catch(Exception ex) {
            ex.printStackTrace();
        }
        while(input.hasNext()) {
            Site newSite = new Site();
            newSite.readFrom(input);
            sites.add(newSite);
        }
        siteList.setItems(sites);
    }  
    
    @FXML
    private void create() {
        Site newSite = new Site(nameField.getText(),userField.getText(),passwordField.getText());
        sites.add(newSite);
    }
    
    @FXML
    private void remove() {
        Site toRemove = (Site) siteList.getSelectionModel().getSelectedItem();
        if(toRemove != null)
            sites.remove(toRemove);
    }

    @FXML
    private void view() {
        Site toView = (Site) siteList.getSelectionModel().getSelectedItem();
        if(toView != null) {
            userLabel.setText(toView.getUser());
            passwordLabel.setText(toView.getPassword());
        }
    }
    
    @FXML
    private void save() {
        PrintWriter output = null;
        try {
            output = new PrintWriter(new File("passwords.txt"));
        } catch(Exception ex) {
            ex.printStackTrace();
        }
        for(Site s : sites) {
            s.writeTo(output);
        }
        output.close();
    }
}
